#ifndef DL_H
#define DL_H


#include <pthread.h>


struct dlqueue;
#include "context.h"
#include "queue.h"
#include "adl.h"

#define DL_MAXDOWNLOADS 10
#define DL_DEFAULTNODERANK 200
#define DL_MAXNODESPERBLOCK 32

typedef struct dlqueue{
	queuetype * blocks;
	//queuetype * ips;
	pthread_mutex_t *lock;
	pthread_cond_t * cond;
	pthread_t *threads;
	blocks * inProgress;
	int blocksDoneCount;
	int threadCount;
}dlqueue;

typedef struct dlelm{
	unsigned int ip;
	unsigned short port;
	int block;
} dlelm;



int downloadFile(struct context *ctx);

/* NOTES:
 * 	1) starting peer downloading from the front shouldn't matter, because we
 * 		are just grabbing what ever is out there.  Also, it should give
 * 		people a common frame of reference
 * 	2) not locking here is ok, b/c we will do locking on the Enqueue, and
 * 		check again, so that way we can reject it if it is going faster
 */


#endif
