#ifndef _HASH_CHECK_H
#define _HASH_CHECK_H

#include <pthread.h>
#include <openssl/evp.h>
#include "context.h"
#include "queue.h"

#define HASH_BUF_SIZE          8192

typedef struct hashCheck_t {

  struct context* theContext;
  queuetype* hashQueue;

  // The thread that will compute the hash requests and respond
  pthread_t* servThread;

  // Synchronization for the queue
  pthread_mutex_t* mutex;
  pthread_cond_t* cond;

  // For using the hash
  const EVP_MD* evp_md;

} hashCheck_t;

void hash_check_handle_client(hashCheck_t* hasher, connection_t* con);
hashCheck_t* hash_check_create(context* c);
int hash_check_calc_hash(hashCheck_t* hasher, size_t offset, size_t len, 
			 unsigned char* md5sum, int* digest_len);

#endif // _HASH_CHECK_H
