#ifndef LEECH_SERVER_H
#define LEECH_SERVER_H

#include <sys/types.h>
#include "connection.h"
//#include "leeches.h"
// default size of leeches array

#ifndef LEECH_ARR_SIZE
#define LEECH_ARR_SIZE          128
#endif

struct leech_t;

typedef struct {
  size_t offset, len;
  int currPos;
  struct leech_t* leech;
} leech_info_t;

typedef struct {
  // user params
  struct context *userParamsP;
  // serving threads
  pthread_t **threadsP;
  // list of leeches to be served or in the process of being served
  queuetype *leechesQP;
  // condition variable 
  pthread_cond_t *leechesQCondP;

  // New fields for the new deal
  fd_set leechSet;
  int maxFD;
  int leechSize; // max # of elts in leeches array
  int currLeeches; // # of elts currently in array
  leech_info_t** leechesP;
  pthread_mutex_t* mutexP;

} leech_server_t;

// Creates a blank slupie daemon. 
leech_server_t* leech_server_create(struct context* theUserParamsP);

void leech_server_destroy(leech_server_t *theCtxtP);

void leech_server_handle_client(leech_server_t *theCtxtP, 
				connection_t *theClientSockP);
int leech_server_run(leech_server_t *theCtxtP);
void do_leech_server_tests();
#endif
