#ifndef NEIGHBOR_H
#define NEIGHBOR_H

#include "connection.h"

typedef struct {
	connection_t* link;
	int updatesPerRound;
	unsigned int ip;
	unsigned short port;
	unsigned short remote_nm_port;
	unsigned short ref; // for reference counts
        int del_flag; // flag for deletion, 1 = to be deleted
} neighbor;

// Just initialize a blank structure
neighbor* neighborCreate(connection_t* link);
neighbor* neighborRef(neighbor* n);

// Disconnects from the neighbor;
void neighborDestroy(neighbor* n);

// Return the fd so we can select on it
int neighborGetFD(neighbor* n);

int neighborSetUpdates(neighbor* n,int);
int neighborGetUpdates(neighbor* n);

void do_neighbor_tests();

#endif
