#ifndef SOURCE_GET_H
#define SOURCE_GET_H

#include "context.h"

#define GETTIMEOUT 60*1000	// 10 seconds

#define CRLF "\r\n"

#define FTP_PROTO	"ftp://"
#define WWW_PROTO	"http://"


#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN	512
#endif

#define CONTENT_LENGTH	"Content-Length"
#define CONTENT_RANGE "Content-Range"
// will query the source for the file size
// will return 0 in case of error
unsigned long getFileSize(char *theURLP);

int source_get(context *, char * buf, int buflen, unsigned int offset, unsigned int len);

int ftp_get(context *, char * buf, int buflen, unsigned int offset, unsigned int len);
int do_ftp_get(char * hostname, char * filename, char * buf, int buflen, 
	       unsigned int offset, unsigned int len);

int www_get(context *, char * buf, int buflen, unsigned int offset, unsigned int len);
int do_www_get(char * hostname, char * filename, unsigned short port, 
		char * buf, int buflen, unsigned int offset, unsigned int len);

int hostnameToIpString(char * hostname,char * ip,int len);
int isBlankLine(char *);

int parseURL(const char *theURLP, char** theHostNameP, unsigned short **thePortP,
	       char** theFileNameP) ;


int do_source_get_tests();


#endif
