#ifndef UPDATES_H
#define UPDATES_H

struct update;
#include "context.h"
#include "neighbor.h"
#include "blocks.h"

/*************************************************************************
 * 	UPDATE FORMAT:
 *
 * UPDATE <type> <number><EOLN>
 * <update1>
 * .
 * .
 * .
 * <updateN>
 * 
 * <update> = <ip: 4 bytes><port: 2 bytes><blocks: fixed length, but depends
 * 	on blocksize>
 **************************************************************************/

/**************************************************************************
 * 	Update Rules:
 * 0 : 	straight bitmap
 * 1 :  (more to come)
 **************************************************************************/

#define BLOCKRULE_BITMAP 	0x00

#define UPDATES_TIMEOUT	3*1000

#define UPDATES_TIME_BETWEEN_UPDATES  1

#define UPDATESTR	"UPDATE"

#define DEFAULT_UPDATES_PER_ROUND 	8

#ifndef MAXNUMOFUPDATES
#define MAXNUMOFUPDATES 256
#endif


typedef struct update {
	unsigned int ip;
	unsigned short port;
	blocks * data;
	int type;
} update;

// do for all connections
int getAllUpdates(struct context *, neighbor **list, int listlen);
pthread_t * spawnSendUpdate(struct context *);

int calcBlocks(struct context *c);


#endif
