
#include <leech_utils.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "utils.h"

size_t leech_file_read(context *ctx, char *buf, size_t offset, size_t len)
{
  off_t ret;

  // maybe mutex lock here...
  pthread_mutex_lock(ctx->flock);
  ret = lseek(ctx->fd, offset, SEEK_SET);
  if (ret == (off_t) -1){
    pthread_mutex_unlock(ctx->flock);
    return -1;
  }
  ret = read(ctx->fd, buf, len);
  // maybe mutex unlock here...

  pthread_mutex_unlock(ctx->flock);
  return ret;
}


size_t leech_file_write(context *ctx, char *buf, size_t offset, size_t len)
{
  off_t ret;
  pthread_mutex_lock(ctx->flock);
  ret = lseek(ctx->fd, offset, SEEK_SET);
  if (ret == (off_t) -1){
    pthread_mutex_unlock(ctx->flock);
    Dprintf("leech_file_write:: lseek failed with %ld, Sasan is retarded\n",ret);
    return -1;
  }
  ret = write(ctx->fd, buf, len);
  pthread_mutex_unlock(ctx->flock);

  return ret;
}

