#ifndef HASHKEYS_H
#define HASHKEYS_H

/* Will produce hash keys for a an integer number. Uses MD5 signature
   as an underlying hash function. */

#include "types.h"

#define MAX_FUNC_NUM 16


typedef struct {
  UINT8  funcBits;            // number of bits in output of each function
  UINT8  funcNum;             // number of function/keys
  UINT32 keys[MAX_FUNC_NUM]; // hash values generated by each function 
} HashKeysCTX;


/* Will initialize the context.
   Preconditions:
      theFuncBits < 32, because output is unsigned int
      theFuncBits * theFuncNum <= 128, because the values will be
      produced by slicing the MD5 digest */
void HashKeysInit(HashKeysCTX *theC,
		  UINT8 theFuncBits,
		  UINT8 theFuncNum);

void HashKeysCalcInt(HashKeysCTX *theC,
		       UINT32 theValue);

void HashKeysCalcStr(HashKeysCTX *theC,
		     const char *theValue);

/* unit test */
void DoHashKeysTest();

#endif
