#ifndef IP_PORT_T
#define IP_PORT_T

extern const unsigned int IP_PORT_BUF_LEN;

typedef struct {
	char ip[22]; // 255.255.255.255
	unsigned short port;
} ip_port_t;
ip_port_t* ip_port_create(const char* ip, unsigned port);
ip_port_t* ip_port_duplicate(ip_port_t*);
void ip_port_destroy(ip_port_t**);
int ip_port_init(ip_port_t*, const char* ip, unsigned short port);
ip_port_t* ip_port_from_string(const char* str);
// 22 is the maximum that will be written. 
const char* ip_port_to_string(const ip_port_t*, char* buf, size_t buflen);

int ip_port_equal(const ip_port_t*,const ip_port_t*);



#endif
