/*
		QUEUE.H
				Rob Sherwood
				2/9/99 9:12pm
		modified in 09/01
*/

#ifndef QUEUE_H
#define QUEUE_H

#include <pthread.h>

#define QUEUE_DATA_THING void *

#define Q_destroy Q_Destroy
#define Q_create Q_Create
#define Q_empty Q_Empty



typedef struct queuedata{
	QUEUE_DATA_THING data;
	struct queuedata * next;
} queuedata;

typedef struct queuetype {
	queuedata *start;
	queuedata *stop;
        // Elena 07Dec02 for synchronization
        pthread_mutex_t *lock;
} queuetype;

queuetype * Q_Create(void);
int Q_Destroy( queuetype *);
int Q_Empty(queuetype *);
QUEUE_DATA_THING Pop(queuetype *);
int Q_size(queuetype *);
#define Q_Enqueue(x,y) Enqueue(x,y)
int Enqueue(queuetype *,QUEUE_DATA_THING);
int Push(queuetype *,QUEUE_DATA_THING);
#define Q_Dequeue(y) Dequeue(y)
QUEUE_DATA_THING Dequeue(queuetype *);
// Elena 07Dec02
// to remove the specific element from the queue
// returns pointer to the element removed, NULL if element not found
QUEUE_DATA_THING Q_Remove(queuetype *, QUEUE_DATA_THING);

// Elena 07Dec02 Thread Safe methods
// will lock the data structure before performing operation
int Q_sizeTS(queuetype *theQP);
QUEUE_DATA_THING Q_RemoveTS(queuetype *, QUEUE_DATA_THING);
int Q_EnqueueTS(queuetype *,QUEUE_DATA_THING);

// Elena 07Dec02 testing 
void do_queue_tests();
#endif
