#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "protocol.h"



// The Protocol Handshake {{{
const char* proto_enum_to_string(protocol_t p) {
	switch(p) {
		case PROTO_UNKNOWN:
			return "UNKNOWN";
		case PROTO_SLURPIED:
			return "SLURPIED";
		case PROTO_NEIGHBOR:
			return "NEIGHBOR";
		case PROTO_LEECH:
			return "LEECH";
		case PROTO_LEECH_PERSIST:
			return "LEECH_PERSIST";
		case PROTO_HASH_CHECK:
			return "HASH_CHECK";
	};
	return "UNKNOWN";
}
protocol_t proto_string_to_enum(const char* s) {
	protocol_t rv;
	rv = ((strcmp(proto_enum_to_string(PROTO_SLURPIED), s) == 0) ? PROTO_SLURPIED : PROTO_UNKNOWN);
	rv = (rv == PROTO_UNKNOWN) ? ((strcmp(proto_enum_to_string(PROTO_NEIGHBOR), s) == 0) ? PROTO_NEIGHBOR : rv) : rv;
	rv = (rv == PROTO_UNKNOWN) ? ((strcmp(proto_enum_to_string(PROTO_LEECH), s) == 0) ? PROTO_LEECH : rv) : rv;
	rv = (rv == PROTO_UNKNOWN) ? ((strcmp(proto_enum_to_string(PROTO_LEECH_PERSIST), s) == 0) ? PROTO_LEECH_PERSIST : rv) : rv;
	rv = (rv == PROTO_UNKNOWN) ? ((strcmp(proto_enum_to_string(PROTO_HASH_CHECK), s) == 0) ? PROTO_HASH_CHECK : rv) : rv;
	return rv;
}
// }}}

