#ifndef PMDB_H
#define PMDB_H

#include "ip_port.h"

#define PMDB_LENGTH	65536
/* Poor Man's Database is a hash bucket, with a link list at each bucket 
 * for collisions
 */

typedef struct drinkersList{
	ip_port_t **data;
	int maxLength;
	int length;
	int lastIndex;
	char *key;
	struct drinkersList *next;
} drinkersList;

typedef struct pmdb {
	drinkersList **data;
	int length;
	pthread_mutex_t *lock;
} pmdb;		// Poor Man's Database


// NOT threadsafe!
drinkersList *drinkersListNew(char *key,int maxLength);
int drinkersListDestroy(drinkersList *);
int drinkersListAdd(drinkersList *dl,ip_port_t *data);

// ARE threadsafe
pmdb * pmdbNew();
int pmdbDestroy(pmdb *);
drinkersList * pmdbFind(pmdb*, char *key);
int pmdbAdd(pmdb*, char *key,drinkersList *);
int do_pmdb_tests();

#endif
