#ifndef SLURPIED_H
#define SLURPIED_H

#include <sys/types.h>
#include <limits.h>
#include <fcntl.h>

#include "connection.h"
#include "pmdb.h"

typedef struct {
	// User Parameters
	unsigned short numOfLastKDrinkers; 

	// Our listening socket
	connection_t* daemon;

	// Database
	// This database contains the list of drinkers
	// The key to the database is the flavor.
	// Duplicates are allowed
	pmdb* drinkersDB; // Hashed

} slurpied_t;

// Creates a blank slupie daemon. 
slurpied_t* slurpied_create(unsigned short numOfLastKDrinkers);
void slurpied_destroy(slurpied_t*);

int slurpied_run(slurpied_t* s);

// Unit Tests
void do_slurpied_tests();
#endif
