#include <iostream>
#include <fstream>
#include <strstream>
#include <string.h>
#include <netdb.h>

using namespace std;

struct host {
  unsigned int ip;
  unsigned short port;
};

struct host addrs[100];

void print_connect(int dist[][100]) {
  int i, j;

  for(i=1; i<=50; i++) {
    for(j=1; j<=50; j++) {
      if(dist[i][j] == 5000)
	cout <<0<<" ";
      else
	cout<<dist[i][j]<<" ";
    }
    cout<<endl;
  }
}

void verify_neighbors(int dist[][100]) {
  int x, y;

  for(x=1; x<=50; x++) {
    for(y=1; y<=50; y++) {
      if(dist[x][y] == 5000 && dist[y][x] !=5000) {
	cout<<"Adding missing connection from "<<x<<" to "<<y<<endl;
	dist[x][y] = 1;
      }
    }
  }
}

int ip_to_index(unsigned int ip) {
  for(int x=0; x<100; x++) {
    if(addrs[x].ip == ip)
      return x;
  }
  return -1;
}

void skip_to(istrstream& in, char skip) {
  do {
    //in.ignore();
  } while(in.get() != skip);
}

void skip(istrstream& in, int num) {
  // skips <num> characters

  for(int x=0; x<num; x++)
    in.ignore();
}

void handle_line(char* line, int dist[][100]) {
  istrstream in(line);
  int num, ts;
  unsigned short port;
  unsigned int addr;
  int duplicates = 0;
  int unique = 0;
  int zeroes = 0;
  int x;

  // Skip "rogue"
  skip(in, strlen("rogue"));
  in >> num;
  if(num > 100 || num < 0) {
    cout << "Whoa we got a bad line" << endl;
    return;
  }
  dist[num][num] = 0;
  skip_to(in, ':');
  skip(in, strlen("NM_LINKS"));
  // Read timestamp
  in >> ts;
  in >> addr;
  // skip ':'
  skip(in, 1);
  in >> port;
  // skip ':'
  skip(in, 1);
  // Read the host:port pairs
  while(in.peek() >= 0) {
    unsigned int their_ip;
    int their_port, index;

    in >> their_ip;
    in.ignore();   // skip ':'
    in >> their_port;
    //cout << "Got neighbor " << their_ip << endl;
    index = ip_to_index(their_ip);
    if(index < 0) {
      cout << "Uh oh we don't know about address " << their_ip << endl;
      continue;
    }
    //cout<<"Their port was " << addrs[index].port<<<endl;
    if(addrs[index].port == 0)
      addrs[index].port = their_port;
    else if(addrs[index].port != their_port && their_port != 0) {
      cout<<"OOPS GOT 2 different ports for same ip" << endl;
      cout<<"for addr "<<addrs[index].ip<<", "<<addrs[index].port<<"!="<<their_port<<endl;
      goto _end;
    }
    else if(their_port == 0) {
      zeroes++;
      goto _end;
    }
    if(dist[num][index] != 5000) {
      duplicates++;
      goto _end;
    }
    dist[num][index] = 1;
    unique++;
  _end:
    in.ignore();
  }
  cout<<"Host " <<num<<" Had " << zeroes << " zeroes, " << duplicates 
      << " duplicates and " << unique << " unique neighbors" << endl;
}

int main(int argc, char** argv) {

  int dist[100][100];
  int i,j,k, x;
  //char host[30];
  hostent* h;

  if(argc != 2) {
    cout << "Usage: " << argv[0] << "<filename>" << endl;
    return -1;
  }

  ifstream in(argv[1]);
  if(!in) {
    cout << "ERROR: Could not open file" << endl;
    return -1;
  }
  for(i=0; i<100; i++)
    for(j=0; j<100; j++)
      dist[i][j] = 5000; // This should be sufficiently large

  memset(addrs, 0, sizeof(addrs));
  h = gethostbyname("rogue01.umiacs.umd.edu");
  if(h == NULL) {
    cout << "Could not resolve rogue01.umiacs.umd.edu.  Exiting" << endl;
    return -1;
  }
  addrs[1].ip = *(unsigned int *)h->h_addr_list[0];
  for(x=2; x<=50; x++) {
    addrs[x].ip = addrs[x-1].ip + 16777216;  // magic, precomputed #
  }
  while(in.peek() >= 0) {
    char line[1024];

    in.getline(line, 1023, '\n');
    handle_line(line, dist);
  }
  verify_neighbors(dist);
  cout<<"Connectivity:"<<endl;
  print_connect(dist);
  for(k=1;k<=50;k++) {
    for(i=1;i<=50;i++)
      for(j=1;j<=50;j++){
	if(dist[i][k]+dist[k][j]<dist[i][j]){
	  dist[i][j]=dist[i][k]+dist[k][j];
	}
      } 
  }
  cout<<"Minimum paths:"<<endl;
  print_connect(dist);
  return 0;
}
