#!/usr/bin/perl -w
# phase 2 summarizer for exp3 and exp4

$baselinefile = "../../../exp-data/exp1-out/summary";
$LAST="50";
if(@ARGV && $ARGV[0] eq "-r"){
	$LAST="48";
	$baselinefile = "../../../exp-data/exp1b-out/summary";
}
@cases = ("1", "2","4","8","16", "32",$LAST);
open BASELINE, $baselinefile or die "open: $baselinefile $!";
while(<BASELINE>){
	chomp;
	($machine, $count,$sum, $avg) = split;
	next if($count==0);
	$sum=$sum;
	$base{$machine}=$avg;
}

foreach $case (@cases){
	open SUMMARY, "summary.$case" or die "open summary.$case:$!";
	while(<SUMMARY>){
		chomp;
		($machine,$avg,$std,$count) = split;
		next if($count==0);
		$std=$std;
#		if((2*$std)>$avg){	# throw out crappy datapoints
#			print STDERR "Skipping $machine - $case: bad data $avg:$std\n";
#			next;
#		}
		$counts{$machine}->{$case} = $avg;
	}
}

foreach $key (keys %counts){
	if(! defined $base{$key}){
		print STDERR "No baseline for '$key'\n";
		next;
	}
	if($base{$key}==0){
		print STDERR "Baseline for $key is zero!\n";
		next;
	}
	printf "%-30s", $key;
	foreach $case (@cases){
		if((defined($counts{$key}->{$case}))&&($counts{$key}->{$case}>0)){
			printf "\t%f", $base{$key}/($counts{$key}->{$case});
		}else {
			printf "\t-";
		}
	}
	printf "\n";
}
		
