#!/bin/sh

USER=umd2
TRUE=true

if [ $# == 0 ] ; then
	echo $0 host slurpie_args >&2
	exit 1
fi

if [ "$1" = "-r" ]; then
	ROGUES=1
	USER=capveg
	#VALGRIND="valgrind --gdb-attach=yes"
	#VALGRIND="valgrind"
	VALGRIND=/usr/bin/time
	shift
else 
	ROGUES=0
fi

HOST=$1
shift

if [ -f ../bin/slurpie ] ; then
	SLURPIE=../bin/slurpie
elif [ -f ./bin/slurpie ] ; then
	SLURPIE=./bin/slurpie
elif [ -f ../../bin/slurpie ] ; then
	SLURPIE=../../bin/slurpie
elif [ -f ../../../bin/slurpie ] ; then
	SLURPIE=../../../bin/slurpie
else
	echo $0 slurpie binary  not found >&2
	exit 1
fi


# copy binary to host
ssh -x -l $USER -o "StrictHostKeyChecking=no" $HOST "killall -q -w slurpie; $TRUE" 
err=$?
if [ $err -ne 0 ] ;  then
	echo Error Connecting to $HOST : $err >&2 
	exit 1
fi
if [ $ROGUES = 0  ] ; then
	echo Copying binary to $HOST
	scp $SLURPIE $USER@${HOST}:  2>&1 
fi
ssh -x -l $USER $HOST $VALGRIND ./slurpie $* 2>&1 

