#!/usr/bin/perl -w

# create summary of experiment 2

foreach $dir (@ARGV){
	opendir DIR, $dir or die "opendir:$!";
	foreach $file (readdir DIR){
		next if($file =~ /^\./);
		open F, "$dir/$file" or die "open:$!";
		while(<F>){
			# Average speed: XXXX KB/S: total time 36  seconds
			next unless(/Average speed: .* KB\/S: total time (\d+)\s+seconds/);
			if(!defined $counts{$file}){
				$counts{$file}=[];
			}
			$ref = $counts{$file};
			push @{$ref}, $1;
		}
	}
}

foreach $key (sort keys %counts){
	$ref = $counts{$key};
	$avg=0;
	$std=0;
	for($i=0;$i<@{$ref};$i++){
		$avg+=${$ref}[$i];
	}
	$avg=$avg/scalar(@$ref);
	for($i=0;$i<@{$ref};$i++){
		$std+=(${$ref}[$i]-$avg)*(${$ref}[$i]-$avg);
	}
	$std=sqrt($std/@{$ref});
	chomp $key;
	$key=~s/\.out//;
	printf "%40s\t%10f\t%10f\t%d\n",$key,$avg,$std, scalar(@{$ref});
}
			
